﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lab5
{
    class GestoreBiblioteca
    {
        private readonly Biblioteca _biblioteca;
        private Logger _Logger;

        public GestoreBiblioteca(Biblioteca biblioteca)
        {
            if (biblioteca == null)
                throw new ArgumentNullException("biblioteca");
            _biblioteca = biblioteca;
        }

        public void OpenLog(Logger logger)
        {
            if (logger == null)
                throw new ArgumentNullException("logger");
            _Logger = logger;
        }

        public void CloseLog()
        {
            if (_Logger != null)
            {
                _Logger.Close();
                _Logger = null;
            }
        }

        public void AggiungiLibro(Libro libro)
        {
            bool isOk = _biblioteca.Aggiungi(libro);
            if (_Logger != null)
                _Logger.TracciaNuovoLibro(libro, isOk);
        }

        public void ModificaLibro(Libro libro)
        {
            bool isOk = _biblioteca.Modifica(libro);
            if (_Logger != null)
                _Logger.TracciaModificaLibro(libro, isOk);
        }

        public void AggiungiPersona(Persona persona)
        {
            bool isOk = _biblioteca.Aggiungi(persona);
            if (_Logger != null)
                _Logger.TracciaNuovaPersona(persona, isOk);
        }

        public void ModificaPersona(Persona persona)
        {
            bool isOk = _biblioteca.Modifica(persona);
            if (_Logger != null)
                _Logger.TracciaModificaPersona(persona, isOk);
        }

        public void AggiungiPrestito(Prestito prestito)
        {
            bool isOk = _biblioteca.Aggiungi(prestito);
            if (_Logger != null)
                _Logger.TracciaNuovoPrestito(prestito, isOk);
        }

        public void RimuoviPrestito(Prestito prestito)
        {
            bool isOk = _biblioteca.Rimuovi(prestito);
            if (_Logger != null)
                _Logger.TracciaCancellazionePrestito(prestito, isOk);
        }
    }
}
